--<ScriptOptions statementTerminator=";"/>


CREATE TABLE TELECOM_DOF.CustomerMaster (
		Id INTEGER  NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		First_Name VARCHAR(15) NOT NULL,
		Middle_Name VARCHAR(15) NOT NULL,
		Last_Name VARCHAR(15)  NOT NULL,
		Title VARCHAR(4) NOT NULL,
		Country VARCHAR(20) NOT NULL,
		State VARCHAR(15) NOT NULL,
		City VARCHAR(15) NOT NULL,
		Email VARCHAR(64) NOT NULL,
		Mobile_Phone_Number VARCHAR(15) NOT NULL,
		Fixed_Line_Phone_Number VARCHAR(15) NOT NULL,
		Street_Nr VARCHAR(8) NOT NULL,
		Street_Name VARCHAR(128) NOT NULL,
		Street_Type VARCHAR(15) NOT NULL,
		Unit_Type VARCHAR(15) NOT NULL,
		Unit_Nr INTEGER NOT NULL,
		Post_Code VARCHAR(16) NOT NULL,
		Account_Id INTEGER NOT NULL
	);

CREATE TABLE TELECOM_DOF.CustomerAccount (
		Id INTEGER  NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Credit_Score VARCHAR(8) NOT NULL
	);
	
CREATE TABLE TELECOM_DOF.ProductOrder (
		Id INTEGER  NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		ProductId VARCHAR(10) NOT NULL,
		Begin_Date TIMESTAMP NOT NULL,
		End_Date TIMESTAMP NOT NULL,
		Status VARCHAR(5) NOT NULL,
		CustomerMaster_ID INTEGER NOT NULL
	);
		
CREATE TABLE TELECOM_DOF.ServiceOrder (
		Id INTEGER  NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Service_Id INTEGER NOT NULL,
		Begin_date DATE NOT NULL,
		End_date TIMESTAMP,
		Status VARCHAR(10) NOT NULL,
		CustomerMaster_ID INTEGER NOT NULL
	);

CREATE TABLE TELECOM_DOF.ProductOrderParameter (
		Id INTEGER  NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		ProductOrderId INTEGER NOT NULL,
		Name VARCHAR(254) NOT NULL,
		Value VARCHAR(128) NOT NULL
	);

CREATE TABLE TELECOM_DOF.ResourceOrder (
		Id INTEGER  NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Resource_Id VARCHAR(10) NOT NULL,
		Begin_date TIMESTAMP NOT NULL,
		End_date TIMESTAMP,
		Status VARCHAR(10) NOT NULL,
		CustomerMaster_ID INTEGER NOT NULL
	);

ALTER TABLE TELECOM_DOF.ResourceOrder ADD CONSTRAINT Resource_Order_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ProductOrder ADD CONSTRAINT ProductOrder_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ProductOrderParameter ADD CONSTRAINT Product_Order_Param_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.CustomerMaster ADD CONSTRAINT Customer_Master_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.CustomerAccount ADD CONSTRAINT Customer_Account_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ServiceOrder ADD CONSTRAINT Service_Order_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ServiceOrder ADD CONSTRAINT Servic_Customer_FK FOREIGN KEY (CustomerMaster_ID)
	REFERENCES TELECOM_DOF.CustomerMaster (Id)
	ON DELETE RESTRICT;

ALTER TABLE TELECOM_DOF.ProductOrderParameter ADD CONSTRAINT Product_Or_Prod_FK FOREIGN KEY (ProductOrderId)
	REFERENCES TELECOM_DOF.ProductOrder (Id)
	ON DELETE RESTRICT;

ALTER TABLE TELECOM_DOF.CustomerMaster ADD CONSTRAINT Custom_Custome_FK FOREIGN KEY (Account_Id)
	REFERENCES TELECOM_DOF.CustomerAccount (Id)
	ON DELETE RESTRICT;

ALTER TABLE TELECOM_DOF.ResourceOrder ADD CONSTRAINT Resour_Custome_FK FOREIGN KEY (CustomerMaster_ID)
	REFERENCES TELECOM_DOF.CustomerMaster (Id)
	ON DELETE RESTRICT;

ALTER TABLE TELECOM_DOF.ProductOrder ADD CONSTRAINT Produ_Customer_FK FOREIGN KEY (CustomerMaster_ID)
	REFERENCES TELECOM_DOF.CustomerMaster (Id)
	ON DELETE RESTRICT;

