/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment;

import java.io.Serializable;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;

import com.ibm.websphere.icp.telecom.db.entities.TelecomBaseObject;

@Entity
@NamedQueries( { @NamedQuery(name = "findAccountById", query = "SELECT OBJECT(cust_acc) FROM Customeraccount cust_acc WHERE cust_acc.id = :id")})
public class Customeraccount extends TelecomBaseObject implements Serializable {
	@Column(name = "CREDIT_SCORE")
	private String creditScore;

	@OneToMany(mappedBy = "account")
	private Set<Customermaster> customermasterCollection;

	private static final long serialVersionUID = 1L;

	public Customeraccount() {
		super();
	}

	public String getCreditScore() {
		return this.creditScore;
	}

	public void setCreditScore(String creditScore) {
		this.creditScore = creditScore;
	}

	public Set<Customermaster> getCustomermasterCollection() {
		return this.customermasterCollection;
	}

	public void setCustomermasterCollection(
			Set<Customermaster> customermasterCollection) {
		this.customermasterCollection = customermasterCollection;
	}

	@Override
	public String toString() {
		return "Account Id : " + this.getId() + " Credit Score : "
				+ this.creditScore;
	}
}
