/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment;

import java.io.Serializable;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;

import com.ibm.websphere.icp.telecom.db.entities.TelecomBaseObject;

@Entity
@NamedQuery(name = "getAllProducts", query = "SELECT product FROM Product product")
public class Product extends TelecomBaseObject implements Serializable {

	private String name;

	private String price;

	@Column(name = "PRICING_MODEL")
	private String pricingModel;

	private String availability;

	private String description;

	@ManyToOne
	private Category category;

	@OneToMany(mappedBy = "productid")
	private Set<Productservices> productservicesCollection;

	@OneToMany(mappedBy = "productid")
	private Set<Productresources> productresourcesCollection;

	private static final long serialVersionUID = 1L;

	public Product() {
		super();
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getPrice() {
		return this.price;
	}

	public void setPrice(String price) {
		this.price = price;
	}

	public String getPricingModel() {
		return this.pricingModel;
	}

	public void setPricingModel(String pricingModel) {
		this.pricingModel = pricingModel;
	}

	public String getAvailability() {
		return this.availability;
	}

	public void setAvailability(String availability) {
		this.availability = availability;
	}

	public String getDescription() {
		return this.description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Category getCategory() {
		return this.category;
	}

	public void setCategory(Category category) {
		this.category = category;
	}

	public Set<Productservices> getProductservicesCollection() {
		return this.productservicesCollection;
	}

	public void setProductservicesCollection(
			Set<Productservices> productservicesCollection) {
		this.productservicesCollection = productservicesCollection;
	}

	public Set<Productresources> getProductresourcesCollection() {
		return this.productresourcesCollection;
	}

	public void setProductresourcesCollection(
			Set<Productresources> productresourcesCollection) {
		this.productresourcesCollection = productresourcesCollection;
	}

}
