/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment;

import java.io.Serializable;
import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.ManyToOne;

import com.ibm.websphere.icp.telecom.db.entities.TelecomBaseObject;

@Entity
public class Resourceorder extends TelecomBaseObject implements Serializable {

	@Column(name = "RESOURCE_ID")
	private String resourceId;

	@Column(name = "BEGIN_DATE")
	private Timestamp beginDate;

	@Column(name = "END_DATE")
	private Timestamp endDate;

	private String status;

	@ManyToOne
	private Customermaster customermaster;

	private static final long serialVersionUID = 1L;

	public Resourceorder() {
		super();
	}

	public String getResourceId() {
		return this.resourceId;
	}

	public void setResourceId(String resourceId) {
		this.resourceId = resourceId;
	}

	public Timestamp getBeginDate() {
		return this.beginDate;
	}

	public void setBeginDate(Timestamp beginDate) {
		this.beginDate = beginDate;
	}

	public Timestamp getEndDate() {
		return this.endDate;
	}

	public void setEndDate(Timestamp endDate) {
		this.endDate = endDate;
	}

	public String getStatus() {
		return this.status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public Customermaster getCustomermaster() {
		return this.customermaster;
	}

	public void setCustomermaster(Customermaster customermaster) {
		this.customermaster = customermaster;
	}

}
