/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment.mock;

import java.sql.Timestamp;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import com.ibm.websphere.icp.industry.db.manager.IWicpDBFactoryConstants;
import com.ibm.websphere.icp.industry.db.manager.IWicpDBManager;
import com.ibm.websphere.icp.industry.db.manager.WicpDBFactory;
import com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment.Customermaster;
import com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment.Resourceorder;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;

/**
 * @author nikunj.panchal
 * 
 */

public class SubmitResourceOrderImpl {
	/**
	 * Default constructor.
	 */
	public SubmitResourceOrderImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this
	 * implementation class. This method should be used when passing this
	 * service to a partner reference or if you want to invoke this component
	 * service asynchronously.
	 * 
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implementation of operation
	 * "submitResourceOrder" defined for WSDL port type named
	 * "SubmitResourceOrderPT".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a
	 * parameter type conveys that it is a complex type. Please refer to the
	 * WSDL Definition for more information on the type of input, output and
	 * fault(s).
	 */
	public DataObject submitResourceOrder(DataObject aResourceOrderMessage) {
		final Resourceorder resourceOrder = new Resourceorder();
		/**
		 * Generate the ServiceOrderId
		 */
		int randomIntegerForResourceOrderId = (int) (100000000 * Math.random());
		String resourceOrderId = String
				.valueOf(randomIntegerForResourceOrderId);
		DataObject resourceOrderDO = aResourceOrderMessage
				.getDataObject("resourceOrder");

		/**
		 * Get the ServiceId
		 */
		String resourceId = resourceOrderDO.getString("Id");
		;
		/**
		 * Get The Service ServiceBeginDate and ServiceEndDate
		 */

		Date resourceBeginDate = resourceOrderDO.getDate("RequestedDate");
		Date resourceEndDate = resourceOrderDO.getDate("ExpectedDeliveryDate");

		/**
		 * Get the Status of the service order
		 */
		String serviceStatus = resourceOrderDO.getString("InteractionStatus");

		/**
		 * Get The CustomerId
		 */
		DataObject specification = resourceOrderDO
				.getDataObject("Specification");
		String customerId = specification.getString("Id");
		/**
		 * Set the Service Order Object
		 */
		resourceOrder.setResourceId(resourceId);
		resourceOrder.setBeginDate(new Timestamp(resourceBeginDate.getTime()));
		resourceOrder.setEndDate(new Timestamp(resourceEndDate.getTime()));
		//resourceOrder.setId(resourceOrderId);
		resourceOrder.setStatus(serviceStatus);

		/**
		 * get the DbFactory and persist data
		 */
		Properties dbProperties = new Properties();
		dbProperties.setProperty(IWicpDBFactoryConstants.TYPE, "JPA");
		dbProperties.setProperty(IWicpDBFactoryConstants.PERSISTENCE_UNIT_NAME,
				"DynamicOrderFulfillmentDBAccess");
		IWicpDBManager wicpDbManager = WicpDBFactory.getDBManager(dbProperties);

		/**
		 * Create the Map to fetch Customer from Db
		 */
		Map<String, Object> mapParams = new HashMap<String, Object>();
		mapParams.put("id", Integer.valueOf(customerId));

		/**
		 * Fetch The Customer record from DB
		 */
		Customermaster customermaster = new Customermaster();

		customermaster = (Customermaster) wicpDbManager.executeNamedQuery(
				"findCustomerById", mapParams).get(0);
		resourceOrder.setCustomermaster(customermaster);

		try {
			wicpDbManager.save(resourceOrder);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return aResourceOrderMessage;
	}

}
