/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
/*********************************************** 
 * Licensed Materials - Property of IBM 
 * 
 * 5724-R31, 5655-S30 
 * 
 * (C) Copyright IBM Corp. 2009 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
 *********************************************** 
 */

package com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment.util;

/**
 * This interface holds all the constants used across the mock services It
 * becomes easy for maintenance
 * 
 * @author nikunj.panchal
 * 
 */

public interface IConstants {

	public final String BOFACTORY = "com/ibm/websphere/bo/BOFactory";
	public final String MTOSI_NS = "http://www.ibm.com/telecom/common/schema/mtosi/v3_0";
	public final String DO_HEADER = "header";
	public final String ERRORCODE = "ErrorCode";
	public final String ERRORCODE_VALUE = "-19141";
	public final String ERROCODE_RESOURCEAVAILIBILITY = "-99991";
	public final String DEFAULT_ERRORCODE_VALUE = "-00000";
	public final String CREDITSCOREVALUE = "100";
	public final String ERRORDESCRIPTION = "ErrorDescription";
	public final String DO_ID = "Id";
	public final String DO_NAME = "Name";
	public final String DO_NAME_SMALL = "name";
	public final String ACTIVITYSTATUS = "activityStatus";
	public final String QUALIFIER = "qualifier";
	public final String FAILURE = "FAILURE";
	public final String MSGTYPE = "msgType";
	public final String RESPONSE = "RESPONSE";
	public final String PROPNAME = "propName";
	public final String EXCEPTION = "Exception";
	public final String PROPVALUE = "propValue";
	public final String MSGSPECIFICPROPERTIES = "msgSpecificProperties";

	// Customer Related
	public final String DO_CUSTOMER = "customer";
	public final String DO_CUSTOMER_ELEMENT = "Customer";
	public final String DO_CUSTOMERMESSAGE = "CustomerMessage";
	public final String NS_CUSTOMERMESSAGE = "http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/inventory/schema/CustomerMessage";
	public final String DO_CUSTOMERCOLLECTIONMESSAGE = "CustomerCollectionMessage";
	public final String NS_CUSTOMER = "http://www.ibm.com/telecom/inventory/schema/customer/v3_0";
	public final String DO_PARTY = "Party";
	public final String DO_CREDITSCORE = "CreditScore";
	public final String DO_CUSTOMERNAME = "/customer/Party/Name";
	public final String DO_PROPERTYTYPE = "PropertyType";

	// Service Related
	public final String NS_SERVICEORDERMESSAGE = "http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/fulfillment/schema/ServiceOrderMessage";
	public final String NS_SERVICE = "http://www.ibm.com/telecom/inventory/schema/service_configuration/v3_0";
	public final String DO_SERVICEORDER = "ServiceOrder";
	public final String DO_NAME_SERVICEORDER = "serviceOrder";
	public final String DO_SERVICEORDERMESSAGE = "ServiceOrderMessage";
	public final String NS_SERVICEORDER = "http://www.ibm.com/telecom/fulfillment/schema/service_order/v3_0";
	public final String DO_SERVICEORDERITEM = "ServiceOrderItem";
	public final String DO_SERVICE = "Service";

	// Resource Related
	public final String NS_RESOURCEORDERMESSAGE = "http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/inventory/schema/ResourceOrderMessage";
	public final String NS_RESOURCEORDERMESSAGE_INVENTORY = "http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/inventory/schema/ResourceOrderMessage";
	public final String NS_RESOURCEORDER = "http://www.ibm.com/telecom/fulfillment/schema/resource_order/v3_0";
	public final String NS_RESOURCE = "http://www.ibm.com/telecom/inventory/schema/resource_configuration/v3_0";
	public final String NS_BUSINESSINTERACTIONENTITY = "http://www.ibm.com/telecom/common/schema/business_interaction/v3_0";
	public final String DO_BUSINESSINTERACTIONENTITY = "BusinessInteractionEntity";
	public final String DO_RESOURCEORDER = "ResourceOrder";
	public final String DO_NAME_RESOURCEORDER = "resourceOrder";
	public final String DO_RESOURCEORDERMESSAGE = "ResourceOrderMessage";
	public final String DO_RESOURCEORDERITEM = "ResourceOrderItem";
	public final String DO_RESOURCE = "Resource";
	public final String DO_PROPERTY = "property";

	// Product Related
	public final String PRODUCT = "Product";
	public final String PRODUCTORDER = "productOrder";
	public final String DO_PRODUCTORDER = "ProductOrder";
	public final String SPECIFICATION = "Specification";
	public final String NS_PRODUCTORDERMESSAGE = "http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/fulfillment/schema/ProductOrderMessage";
	public final String NS_PRODUCTORDER = "http://www.ibm.com/telecom/fulfillment/schema/product_order/v3_0";
	public final String NS_ORDERDECOMPOSITIONMESSAGE = "http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/fulfillment/schema/OrderDecompositionMessage";
	public final String PRODUCTORDERMESSAGE = "ProductOrderMessage";
	public final String DO_PRODUCTORDERMESSAGE = "ProductOrderMessage";
	public final String PRODUCTORDERITEM = "ProductOrderItem";
	public final String DO_PRODUCT = "Product";
	public final String DO_ORDERDECOMPOSITIONMESSAGE = "OrderDecompositionMessage";



	// Properties file
	public final String CHECKTECHNICALAVAILABILITYPROPERTIES = "CheckTechnicalAvailability.properties";
	public final String NOTIFICATIONPROPERTIES = "Notification.properties";
	public final String SERVICE_APPROVED = "SERVICE APPROVED";
	public final String SERVICE_DECLINED = "SERVICE DECLINED";

}
