/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.util;

import java.util.Iterator;
import java.util.List;

import commonj.sdo.DataObject;

public class ValuesFromCharacteristics {
		
	public static List<String> characteristicValuesFromCharacteristicName(List<DataObject> characteristicValues, String matchingName) {
		List values = null;
		try {
			Iterator<DataObject> iterator = characteristicValues.iterator();
			while(iterator.hasNext()) {
				DataObject characteristicValue = (DataObject) iterator.next();
				DataObject characteristic = (DataObject) characteristicValue.get("Characteristic");
				String name = characteristic.getString("Name");
				if(matchingName.equals(name)) {
					values = (List<String>) characteristicValue.getList("Value");
					break;
				}
			}
		} catch(Exception e) {
			e.printStackTrace();
		}

		return values;
	}
	
	public static String firstcharacteristicValueFromCharacteristicName(List<DataObject> characteristicValues, String matchingName) {
		String value = null;
		List<String> values = characteristicValuesFromCharacteristicName(characteristicValues, matchingName);
		if(values != null) {
			value = values.get(0);
		}
		return value;
	}
}
