--<ScriptOptions statementTerminator=";"/>

CONNECT 'WICPDB;create=true;territory=EN_US' as WICPDB; 

--<ScriptOptions statementTerminator=";"/>

CREATE TABLE TELECOM_DOF.ServiceOrder (
		Id INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Service_Id INTEGER NOT NULL,
		Begin_date TIMESTAMP NOT NULL,
		End_date TIMESTAMP,
		Status VARCHAR(10) NOT NULL,
		CustomerMaster_ID INTEGER NOT NULL
	);

CREATE TABLE TELECOM_DOF.ProductOrder (
		Id INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		ProductId VARCHAR(10) NOT NULL,
		Begin_Date TIMESTAMP NOT NULL,
		End_Date TIMESTAMP NOT NULL,
		Status VARCHAR(5) NOT NULL,
		CustomerMaster_ID INTEGER NOT NULL
	);

CREATE TABLE TELECOM_DOF.ProductResources (
		ProductId INTEGER NOT NULL,
		ResourceID INTEGER NOT NULL,
		Id INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1)
	);

CREATE TABLE TELECOM_DOF.Product (
		Id INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Name VARCHAR(65) NOT NULL,
		Price VARCHAR(8) NOT NULL,
		Pricing_Model VARCHAR(16) NOT NULL,
		Availability VARCHAR(16) DEFAULT NULL,
		Category_Id INTEGER NOT NULL,
		Description VARCHAR(128) DEFAULT NULL
	);

CREATE TABLE TELECOM_DOF.Resource (
		Id INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Name VARCHAR(32) NOT NULL,
		Type VARCHAR(32) NOT NULL,
		ResourceType VARCHAR(32) NOT NULL,
		ServiceId INTEGER NOT NULL
	);

CREATE TABLE TELECOM_DOF.ProductOrderParameter (
		Id INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		ProductOrderId INTEGER NOT NULL,
		Name VARCHAR(254) NOT NULL,
		Value VARCHAR(128) NOT NULL
	);

CREATE TABLE TELECOM_DOF.ResourceOrder (
		Id INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Resource_Id VARCHAR(10) NOT NULL,
		Begin_date TIMESTAMP NOT NULL,
		End_date TIMESTAMP,
		Status VARCHAR(10) NOT NULL,
		CustomerMaster_ID INTEGER NOT NULL
	);

CREATE TABLE TELECOM_DOF.CustomerMaster (
		Id INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		First_Name VARCHAR(15) NOT NULL,
		Middle_Name VARCHAR(15) NOT NULL,
		Last_Name VARCHAR(15) NOT NULL,
		Title VARCHAR(4) DEFAULT NULL,
		Country VARCHAR(20) ,
		State VARCHAR(15) NOT NULL,
		City VARCHAR(15) NOT NULL,
		Email VARCHAR(64) NOT NULL,
		Mobile_Phone_Number VARCHAR(15) NOT NULL,
		Fixed_Line_Phone_Number VARCHAR(15) ,
		Street_Nr VARCHAR(8) DEFAULT NULL,
		Street_Name VARCHAR(128) DEFAULT NULL,
		Street_Type VARCHAR(15) DEFAULT NULL,
		Unit_Type VARCHAR(15) DEFAULT NULL,
		Unit_Nr INTEGER DEFAULT NULL,
		Post_Code VARCHAR(16) DEFAULT NULL,
		Account_Id INTEGER NOT NULL
	);

CREATE TABLE TELECOM_DOF.CustomerAccount (
		Id INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Credit_Score VARCHAR(8) NOT NULL
	);

CREATE TABLE TELECOM_DOF.Service (
		Id INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Name VARCHAR(32) NOT NULL,
		Type VARCHAR(8) NOT NULL,
		ServiceType VARCHAR(32) NOT NULL
	);

CREATE TABLE TELECOM_DOF.ProductServices (
		ProductId INTEGER NOT NULL,
		ServiceId INTEGER NOT NULL,
		Id INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1)
	);

CREATE TABLE TELECOM_DOF.Category (
		Id INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Name VARCHAR(64) NOT NULL,
		Description VARCHAR(128) NOT NULL
	);

ALTER TABLE TELECOM_DOF.CustomerMaster ADD CONSTRAINT Customer_Master_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.Resource ADD CONSTRAINT Resource_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.Category ADD CONSTRAINT Category_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ProductServices ADD CONSTRAINT Product_Services_1 PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.Service ADD CONSTRAINT Service_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ResourceOrder ADD CONSTRAINT Resource_Order_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ProductOrderParameter ADD CONSTRAINT Product_Order_Par1 PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.Product ADD CONSTRAINT Product_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ServiceOrder ADD CONSTRAINT Service_Order_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.CustomerAccount ADD CONSTRAINT Customer_Account_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ProductResources ADD CONSTRAINT Product_Resources1 PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ProductOrder ADD CONSTRAINT ProductOrder_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ProductOrder ADD CONSTRAINT Produ_Customer_FK FOREIGN KEY (CustomerMaster_ID)
	REFERENCES TELECOM_DOF.CustomerMaster (Id)
	ON DELETE CASCADE;

ALTER TABLE TELECOM_DOF.ProductResources ADD CONSTRAINT Product_Re_Reso_FK FOREIGN KEY (ResourceID)
	REFERENCES TELECOM_DOF.Resource (Id)
	ON DELETE CASCADE;

ALTER TABLE TELECOM_DOF.ProductServices ADD CONSTRAINT Product_Se_Prod_FK FOREIGN KEY (ProductId)
	REFERENCES TELECOM_DOF.Product (Id)
	ON DELETE CASCADE;

ALTER TABLE TELECOM_DOF.Resource ADD CONSTRAINT Resourc_Servic_FK FOREIGN KEY (ServiceId)
	REFERENCES TELECOM_DOF.Service (Id)
	ON DELETE CASCADE;

ALTER TABLE TELECOM_DOF.CustomerMaster ADD CONSTRAINT Custom_Custome_FK FOREIGN KEY (Account_Id)
	REFERENCES TELECOM_DOF.CustomerAccount (Id)
	ON DELETE CASCADE;

ALTER TABLE TELECOM_DOF.ResourceOrder ADD CONSTRAINT Resour_Custome_FK FOREIGN KEY (CustomerMaster_ID)
	REFERENCES TELECOM_DOF.CustomerMaster (Id)
	ON DELETE CASCADE;

ALTER TABLE TELECOM_DOF.ProductResources ADD CONSTRAINT Product_Re_Prod_FK FOREIGN KEY (ProductId)
	REFERENCES TELECOM_DOF.Product (Id)
	ON DELETE CASCADE;

ALTER TABLE TELECOM_DOF.ProductOrderParameter ADD CONSTRAINT Product_Or_Prod_FK FOREIGN KEY (ProductOrderId)
	REFERENCES TELECOM_DOF.ProductOrder (Id)
	ON DELETE CASCADE;

ALTER TABLE TELECOM_DOF.Product ADD CONSTRAINT Produc_Categor_FK FOREIGN KEY (Category_Id)
	REFERENCES TELECOM_DOF.Category (Id)
	ON DELETE CASCADE;

ALTER TABLE TELECOM_DOF.ProductServices ADD CONSTRAINT Product_Se_Serv_FK FOREIGN KEY (ServiceId)
	REFERENCES TELECOM_DOF.Service (Id)
	ON DELETE CASCADE;

ALTER TABLE TELECOM_DOF.ServiceOrder ADD CONSTRAINT Servic_Customer_FK FOREIGN KEY (CustomerMaster_ID)
	REFERENCES TELECOM_DOF.CustomerMaster (Id)
	ON DELETE CASCADE;

INSERT INTO TELECOM_DOF.CATEGORY (NAME, DESCRIPTION)
  VALUES ('Wireless Products', 'Wireless'),
         ('Mobile Products', 'Mobile');

INSERT INTO TELECOM_DOF.PRODUCT (NAME, PRICE, PRICING_MODEL, AVAILABILITY,
  CATEGORY_ID, DESCRIPTION)
  VALUES ('Access Line', '80', 'Solo', 'Available', (Select Id from TELECOM_DOF.Category where description='Wireless'), 'AccessLine'),
         ('Directory Listing', '95', 'Solo', 'Available', (Select Id from TELECOM_DOF.Category where description='Wireless'),
           'Directory Listing'),
         ('Conferencing', '750', 'Solo', 'Available', (Select Id from TELECOM_DOF.Category where description='Mobile'), 'Conferencing'),
         ('Enhanced Services', '836', 'Solo', 'Available', (Select Id from TELECOM_DOF.Category where description='Mobile'),
           'Enhanced Services'),
         ('Healthcare Services', '558', 'Solo', 'Available', (Select Id from TELECOM_DOF.Category where description='Mobile'),
           'Healthcare Services');

insert into TELECOM_DOF.SERVICE (NAME,TYPE,SERVICETYPE) values ('WIRELESS_SERVICE','WIRELESS','WIRELESS') ,
('MOBILE_SERVICE','MOBILE','MOBILE');

insert into TELECOM_DOF.RESOURCE (NAME,TYPE,RESOURCETYPE,SERVICEID) values ('RESOURCE_WIRELESS_1','WIRELESS','WIRELESS',(Select id from TELECOM_DOF.Service where TYPE='WIRELESS')),
('RESOURCE_WIRELESS_2','WIRELESS','WIRELESS',(Select id from TELECOM_DOF.Service where TYPE='WIRELESS')),
('RESOURCE_MOBILE_1','MOBILE','MOBILE',(Select id from TELECOM_DOF.Service where TYPE='MOBILE'))
,
('RESOURCE_MOBILE_2','MOBILE','MOBILE',(Select id from TELECOM_DOF.Service where TYPE='MOBILE'));

insert into TELECOM_DOF.CustomerAccount (Credit_Score) values ('600') ,('700'),('800'),('900'),('1000');

insert into TELECOM_DOF.CustomerMaster (First_Name,Middle_Name,Last_Name,Title,Country,State,City,Email,Mobile_Phone_Number,Fixed_Line_Phone_Number,Street_Nr,Street_Name,
                Street_Type,Unit_Type,Unit_Nr,Post_Code,Account_Id) values 
                ('Charlie','C','Change','Mr','US','CA','California','charlie.change@chan.com','(111) 111-1111','(111) 111-1112','1210','Valley Street','Road','Bungalow',123,'32420',
                (Select Id from TELECOM_DOF.CustomerAccount where Credit_Score='600')),
                ('Max','M','Milan','Mr','US','TX','Texas','max.milan@abc.com','(222) 222-2222','(222) 222-2223','1310','Sixth Avenue','Road','Bungalow',333,'32423',
                (Select Id from TELECOM_DOF.CustomerAccount where Credit_Score='700')),
                ('John','J','Mathew','Mr','US','NY','Newyork','john.mathew@mat.com','(333) 333-3333','(333) 333-3334','6789','Malbone Street','Road','Bungalow',1234,'23434',
                (Select Id from TELECOM_DOF.CustomerAccount where Credit_Score='800')),
                ('John','D','Doe','Mr','US','AZ','Arizona','john.doe@mat.com','(444) 444-4444','(444) 444-4445','6789','23rd Street','Road','Bungalow',1234,'23434',
                (Select Id from TELECOM_DOF.CustomerAccount where Credit_Score='900')),
                ('Jane','S','Sung','Mr','US','MT','Montana','jane.sung@mat.com','(555) 555-5555','(555) 555-5556','6789','16th Street','Road','Bungalow',1234,'23434',
                (Select Id from TELECOM_DOF.CustomerAccount where Credit_Score='1000'));